; wscitecm.nsi
; Script generated with the Venis Install Wizard

; Define your application name
!define APPNAME "Context Menu Extension for SciTE"
!define APPNAMEANDVERSION "Context Menu Extension for SciTE 1.2.4"
!define DO_UNINSTALL $R0

; Main Install settings
Name "${APPNAMEANDVERSION}"
InstallDir "$PROGRAMFILES\SciTE"
InstallDirRegKey HKLM "Software\${APPNAME}" ""
OutFile "wscitecm124.exe"

; Modern interface settings
!include "MUI.nsh"

!define MUI_ABORTWARNING

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "license.txt"
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH

!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_UNPAGE_FINISH

; Set languages (first is default language)
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_RESERVEFILE_LANGDLL


Section "Context Menu for SciTE" ContextMenuSection

	; Set Section properties
	SectionIn RO ; Make section readonly
	SetOverwrite try ; Try to overwrite file, but supress warning messages
	SetOutPath "$INSTDIR" ; Set the install path that was browsed by user
	SetRebootFlag false ; Reset the reboot flag
	
	Delete /REBOOTOK "$INSTDIR\wscitecm.dll" ; Try to delete the existing wscitecm.dll
	IfRebootFlag DoRebootBeforeContinue NoRebootNeeded
	
	; Lets prevent the uninstaller from writing and let this install
	; finish so the user may reboot
	DoRebootBeforeContinue:
		
		UnRegDLL "$INSTDIR\wscitecm.dll" ; Unregister the dll so we can delete it upon reboot
		MessageBox MB_YESNO|MB_ICONEXCLAMATION "The existing wscitecm.dll has been marked for deletion upon system restart.$\nWould you like to restart now?" IDNO NoReboot
		
			MessageBox MB_OK|MB_ICONINFORMATION "NOTE: Installation is not complete.$\n$\nYou will need to run this setup again after rebooting your computer."
			Reboot
			Quit
		
		NoReboot:
			MessageBox MB_OK|MB_ICONINFORMATION "NOTE: Installation is not complete.$\n$\nYou will need to run this setup again after rebooting your computer."
			Quit

	NoRebootNeeded:
	
	File "wscitecm.dll"
	File "wscitecm.html"
	RegDLL "$INSTDIR\wscitecm.dll"

SectionEnd

Section "Create Uninstaller" UninstallSection

	StrCmp ${DO_UNINSTALL} "NO" SkipUninstall
		SetOutPath "$INSTDIR"
		WriteUninstaller "$INSTDIR\wscitecm-uninst.exe"
		WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "DisplayName" "${APPNAME}"
		WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}" "UninstallString" "$INSTDIR\uninstall.exe"
		WriteRegStr HKLM "Software\${APPNAME}" "" "$INSTDIR"
	SkipUninstall:
	
SectionEnd


; Modern install component descriptions
!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
	!insertmacro MUI_DESCRIPTION_TEXT ${ContextMenuSection} "Installing this Context Menu Handler (wscitecm.dll) creates a new command 'Edit with SciTE' in the context menu of Windows Explorer."
	!insertmacro MUI_DESCRIPTION_TEXT ${UninstallSection} "Create Uninstaller for wscitecm.dll. This will unregister the wscitecm.dll."
!insertmacro MUI_FUNCTION_DESCRIPTION_END

Function .onVerifyInstDir

	IfFileExists $INSTDIR\SciTE.exe PathGood
		Abort
	PathGood:

FunctionEnd

;Uninstall section
Section Uninstall

	; Unregister DLL
	UnRegDLL "$INSTDIR\wscitecm.dll"
	
	; Remove from registry...
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${APPNAME}"
	DeleteRegKey HKLM "SOFTWARE\${APPNAME}"

	; Clean up Context Menu Extension for SciTE install
	Delete /REBOOTOK "$INSTDIR\wscitecm.dll"
	Delete /REBOOTOK "$INSTDIR\wscitecm.html"
	Delete /REBOOTOK "$INSTDIR\wscitecm-uninst.exe"

SectionEnd

BrandingText "2004 http://www.spaceblue.com"

; eof